<template>
  <b-container class="group-ctrl-slot p-0" fluid="xl">
    <b-row class="justify-content-md-center p-0" align-v="center">
      <b-col class="">
        <div
          class="btn-group w-100"
          role="group"
          aria-label="Button group with nested dropdown"
        >
          <div class="btn-group w-100" role="group">
            <treeselect
              ref="refRuleTreeselect"
              :options="getDatasetsTree()"
              :disable-branch-nodes="true"
              :show-count="true"
              data-cy="input-field-qf"
              placeholder="Select a field"
              no-results-text="Field not found"
              clear-value-text="Remove field"
              no-options-text="No fields available"
              no-children-text="No sub-fields"
              :default-expand-level="0"
              search-nested
              @select="setRule"
            >
              <label
                slot="option-label"
                slot-scope="{
                  node,
                  shouldShowCount,
                  count,
                  labelClassName,
                  countClassName,
                }"
                :class="
                  'text-' +
                  node.raw.color +
                  ' font-weight-bold ' +
                  labelClassName
                "
              >
                <b-container class="m-0 p-0" fluid>
                  <b-row no-gutters>
                    <b-col class="mr-2">
                      <component
                        :is="node.raw.icon + '-icon'"
                        class="icon-xxs mr-1"
                      /><span>{{ node.label }}</span>
                      <span v-if="shouldShowCount" :class="countClassName"
                        >({{ count }})</span
                      >
                    </b-col>
                  </b-row>
                  <b-row no-gutters>
                    <b-col
                      style="
                        font-size: 0.9em;
                        margin-left: 1.3em;
                        line-height: 1.3;
                      "
                      class="mr-2"
                    >
                      <span class="small font-italic text-wrap text-muted">
                        {{ node.raw.description }}
                      </span>
                    </b-col>
                  </b-row>
                </b-container>
              </label>
              <div slot="value-label" slot-scope="{ node }">
                <component
                  :is="node.raw.icon + '-icon'"
                  class="icon-xxs mr-1"
                /><span>{{ node.label }}</span>
              </div>
            </treeselect>
          </div>
          <button
            type="button"
            style="padding-left: 1em"
            data-cy="btn-rule-qf"
            class="btn btn-sm pt-1 pb-1 pr-3 rounded-0"
            :disabled="selectedRule === ''"
            @click="addRule"
          >
            <StackIcon class="icon-xxs" /> Rule
          </button>
          <button
            type="button"
            class="btn btn-sm pt-1 pb-1 pl-3 pr-2 rounded-0"
            @click="groupCtrl.newGroup"
          >
            <FolderPlusIcon class="icon-xxs" /> Group
          </button>
        </div>
      </b-col>
    </b-row>
  </b-container>
</template>

<script>
import Treeselect from '@riophae/vue-treeselect';
import '@riophae/vue-treeselect/dist/vue-treeselect.css';
import queryFactoryConstants from './constants/queryFactory';

export default {
  components: {
    Treeselect,
  },
  props: {
    rsmlInputParameter: {
      type: Object,
      default: () => {},
    },
    groupCtrl: {
      type: Object,
      default: () => {},
    },
  },
  data() {
    return {
      selectedRule: '',
    };
  },
  computed: {
    ruleName() {
      if (this.selectedRule === '') {
        return '';
      }

      return this.groupCtrl.rules.find(
        (r) => r.identifier === this.selectedRule
      ).name;
    },
    datasets() {
      return this.rsmlInputParameter?.options?.properties?.datasets;
    },
  },
  methods: {
    setRule(node) {
      this.selectedRule = node.id;
    },
    addRule() {
      if (!this.selectedRule) {
        return;
      }

      this.$refs.refRuleTreeselect.clear();
      this.groupCtrl.addRule(this.selectedRule);
      this.selectedRule = '';
    },
    getDatasetsTree() {
      const datasetsSources = this?.datasets?.sources;
      const datasetsTree = [];
      for (const prop of Object.values(this.groupCtrl.rules)) {
        const node = {
          id: prop.identifier,
          label: prop.name,
          color: queryFactoryConstants.identifierPartLabelColor.fields,
          icon: queryFactoryConstants.fieldTypeIconName(prop.type),
          description: prop.description || '',
        };
        let source = datasetsTree.find((s) => s.id === prop.sourceId);
        if (!source) {
          source = {
            id: prop.sourceId,
            label: datasetsSources[prop.sourceId].title,
            color: queryFactoryConstants.identifierPartLabelColor.sources,
            icon: queryFactoryConstants.identifierPartIconName('sources'),
            description: datasetsSources[prop.sourceId].description || '',
            children: [],
          };
          datasetsTree.push(source);
        }
        let sourceEntity = source.children.find(
          (e) => e.id === `${prop.sourceId}.${prop.entityId}`
        );
        if (!sourceEntity) {
          sourceEntity = {
            id: `${prop.sourceId}.${prop.entityId}`,
            label:
              datasetsSources[prop.sourceId].options.properties.entities[
                `${prop.sourceId}.${prop.entityId}`
              ].title,
            color: queryFactoryConstants.identifierPartLabelColor.entities,
            icon: queryFactoryConstants.identifierPartIconName('entities'),
            description:
              datasetsSources[prop.sourceId].options.properties.entities[
                `${prop.sourceId}.${prop.entityId}`
              ].description || '',
            children: [],
          };
          source.children.push(sourceEntity);
        }
        sourceEntity.children.push(node);
      }
      // we have only a single data source, build instead a 2-level menu
      if (datasetsTree.length === 1) {
        return datasetsTree[0].children;
      }
      return datasetsTree;
    },
  },
};
</script>

<style scoped>
.group-ctrl-slot {
  margin-top: 6px;
  margin-bottom: 6px;
}
.vue-treeselect svg {
  fill: none !important;
}
::v-deep .vue-treeselect__single-value {
  color: #7955af !important;
  font-weight: 500;
}
::v-deep .vue-treeselect__placeholder {
  margin-left: 3px !important;
  color: #6574cd !important;
  font-weight: 450;
}
::v-deep .vue-treeselect__input {
  color: #7955af !important;
}
</style>
